Index: select.c
===================================================================
--- select.c	(revision d4927a70549407fe7f56b4ae1d3949663a370205)
+++ select.c	(revision f0781ba39249518a5e78dc0ec433738ef80f581a)
@@ -1,14 +1,13 @@
 #include "owl.h"
 
+static GMainLoop *loop = NULL;
+static GMainContext *main_context;
 static int dispatch_active = 0;
-static int psa_active = 0;
-static int loop_active = 0;
-
-int _owl_select_timer_cmp(const owl_timer *t1, const owl_timer *t2) {
+
+static GSource *owl_timer_source;
+static GSource *owl_io_dispatch_source;
+
+static int _owl_select_timer_cmp(const owl_timer *t1, const owl_timer *t2) {
   return t1->time - t2->time;
-}
-
-int _owl_select_timer_eq(const owl_timer *t1, const owl_timer *t2) {
-  return t1 == t2;
 }
 
@@ -43,19 +42,64 @@
 }
 
-void owl_select_process_timers(struct timespec *timeout)
-{
-  time_t now = time(NULL);
-  GList **timers = owl_global_get_timerlist(&g);
-
+static gboolean owl_timer_prepare(GSource *source, int *timeout) {
+  GList **timers = owl_global_get_timerlist(&g);
+  GTimeVal now;
+
+  /* TODO: In the far /far/ future, g_source_get_time is what the cool
+   * kids use to get system monotonic time. */
+  g_source_get_current_time(source, &now);
+
+  /* FIXME: bother with millisecond accuracy now that we can? */
+  if (*timers) {
+    owl_timer *t = (*timers)->data;
+    *timeout = t->time - now.tv_sec;
+    if (*timeout <= 0) {
+      *timeout = 0;
+      return TRUE;
+    }
+    if (*timeout > 60 * 1000)
+      *timeout = 60 * 1000;
+  } else {
+    *timeout = 60 * 1000;
+  }
+  return FALSE;
+}
+
+static gboolean owl_timer_check(GSource *source) {
+  GList **timers = owl_global_get_timerlist(&g);
+  GTimeVal now;
+
+  /* TODO: In the far /far/ future, g_source_get_time is what the cool
+   * kids use to get system monotonic time. */
+  g_source_get_current_time(source, &now);
+
+  /* FIXME: bother with millisecond accuracy now that we can? */
+  if (*timers) {
+    owl_timer *t = (*timers)->data;
+    return t->time >= now.tv_sec;
+  }
+  return FALSE;
+}
+
+
+static gboolean owl_timer_dispatch(GSource *source, GSourceFunc callback, gpointer user_data) {
+  GList **timers = owl_global_get_timerlist(&g);
+  GTimeVal now;
+
+  /* TODO: In the far /far/ future, g_source_get_time is what the cool
+   * kids use to get system monotonic time. */
+  g_source_get_current_time(source, &now);
+
+  /* FIXME: bother with millisecond accuracy now that we can? */
   while(*timers) {
     owl_timer *t = (*timers)->data;
     int remove = 0;
 
-    if(t->time > now)
+    if(t->time > now.tv_sec)
       break;
 
     /* Reschedule if appropriate */
     if(t->interval > 0) {
-      t->time = now + t->interval;
+      t->time = now.tv_sec + t->interval;
       *timers = g_list_remove(*timers, t);
       *timers = g_list_insert_sorted(*timers, t,
@@ -71,18 +115,16 @@
     }
   }
-
-  if(*timers) {
-    owl_timer *t = (*timers)->data;
-    timeout->tv_sec = t->time - now;
-    if (timeout->tv_sec > 60)
-      timeout->tv_sec = 60;
-  } else {
-    timeout->tv_sec = 60;
-  }
-
-  timeout->tv_nsec = 0;
-}
-
-static const owl_io_dispatch *owl_select_find_io_dispatch_by_fd(const int fd)
+  return TRUE;
+}
+
+static GSourceFuncs owl_timer_funcs = {
+  owl_timer_prepare,
+  owl_timer_check,
+  owl_timer_dispatch,
+  NULL
+};
+
+/* Returns the valid owl_io_dispatch for a given file descriptor. */
+static owl_io_dispatch *owl_select_find_valid_io_dispatch_by_fd(const int fd)
 {
   int i, len;
@@ -93,5 +135,5 @@
   for(i = 0; i < len; i++) {
     d = owl_list_get_element(dl, i);
-    if (d->fd == fd) return d;
+    if (d->fd == fd && d->valid) return d;
   }
   return NULL;
@@ -112,4 +154,12 @@
   }
   return -1;
+}
+
+static void owl_select_invalidate_io_dispatch(owl_io_dispatch *d)
+{
+  if (d == NULL || !d->valid)
+    return;
+  d->valid = false;
+  g_source_remove_poll(owl_io_dispatch_source, &d->pollfd);
 }
 
@@ -125,4 +175,5 @@
         d->needs_gc = 1;
       else {
+	owl_select_invalidate_io_dispatch(d);
         owl_list_remove_element(dl, elt);
         if (d->destroy)
@@ -134,5 +185,5 @@
 }
 
-void owl_select_io_dispatch_gc(void)
+static void owl_select_io_dispatch_gc(void)
 {
   int i;
@@ -152,5 +203,5 @@
 }
 
-/* Each FD may have at most one dispatcher.
+/* Each FD may have at most one valid dispatcher.
  * If a new dispatch is added for an FD, the old one is removed.
  * mode determines what types of events are watched for, and may be any combination of:
@@ -161,6 +212,8 @@
   owl_io_dispatch *d = g_new(owl_io_dispatch, 1);
   owl_list *dl = owl_global_get_io_dispatch_list(&g);
+  owl_io_dispatch *other;
 
   d->fd = fd;
+  d->valid = true;
   d->needs_gc = 0;
   d->mode = mode;
@@ -169,5 +222,19 @@
   d->data = data;
 
-  owl_select_remove_io_dispatch(owl_select_find_io_dispatch_by_fd(fd));
+  /* TODO: Allow changing fd and mode in the middle? Probably don't care... */
+  d->pollfd.fd = fd;
+  d->pollfd.events = 0;
+  if (d->mode & OWL_IO_READ)
+    d->pollfd.events |= G_IO_IN | G_IO_HUP | G_IO_ERR;
+  if (d->mode & OWL_IO_WRITE)
+    d->pollfd.events |= G_IO_OUT | G_IO_ERR;
+  if (d->mode & OWL_IO_EXCEPT)
+    d->pollfd.events |= G_IO_PRI | G_IO_ERR;
+  g_source_add_poll(owl_io_dispatch_source, &d->pollfd);
+
+
+  other = owl_select_find_valid_io_dispatch_by_fd(fd);
+  if (other)
+    owl_select_invalidate_io_dispatch(other);
   owl_list_append_element(dl, d);
 
@@ -175,37 +242,39 @@
 }
 
-int owl_select_prepare_io_dispatch_fd_sets(fd_set *rfds, fd_set *wfds, fd_set *efds) {
-  int i, len, max_fd;
-  owl_io_dispatch *d;
-  owl_list *dl = owl_global_get_io_dispatch_list(&g);
-
-  max_fd = 0;
+static gboolean owl_io_dispatch_prepare(GSource *source, int *timeout) {
+  *timeout = -1;
+  return FALSE;
+}
+
+static gboolean owl_io_dispatch_check(GSource *source) {
+  int i, len;
+  const owl_list *dl;
+
+  dl = owl_global_get_io_dispatch_list(&g);
+  len = owl_list_get_size(dl);
+  for(i = 0; i < len; i++) {
+    owl_io_dispatch *d = owl_list_get_element(dl, i);
+    if (!d->valid) continue;
+    if (d->pollfd.revents & G_IO_NVAL) {
+      owl_function_debugmsg("Pruning defunct dispatch on fd %d.", d->fd);
+      owl_select_invalidate_io_dispatch(d);
+    }
+    if (d->pollfd.revents & d->pollfd.events)
+      return TRUE;
+  }
+  return FALSE;
+}
+
+static gboolean owl_io_dispatch_dispatch(GSource *source, GSourceFunc callback, gpointer user_data) {
+  int i, len;
+  const owl_list *dl;
+
+  dispatch_active = 1;
+  dl = owl_global_get_io_dispatch_list(&g);
   len = owl_list_get_size(dl);
   for (i = 0; i < len; i++) {
-    d = owl_list_get_element(dl, i);
-    if (d->mode & (OWL_IO_READ | OWL_IO_WRITE | OWL_IO_EXCEPT)) {
-      if (max_fd < d->fd) max_fd = d->fd;
-      if (d->mode & OWL_IO_READ) FD_SET(d->fd, rfds);
-      if (d->mode & OWL_IO_WRITE) FD_SET(d->fd, wfds);
-      if (d->mode & OWL_IO_EXCEPT) FD_SET(d->fd, efds);
-    }
-  }
-  return max_fd + 1;
-}
-
-void owl_select_io_dispatch(const fd_set *rfds, const fd_set *wfds, const fd_set *efds, const int max_fd)
-{
-  int i, len;
-  owl_io_dispatch *d;
-  owl_list *dl = owl_global_get_io_dispatch_list(&g);
-
-  dispatch_active = 1;
-  len = owl_list_get_size(dl);
-  for (i = 0; i < len; i++) {
-    d = owl_list_get_element(dl, i);
-    if (d->fd < max_fd && d->callback != NULL &&
-        ((d->mode & OWL_IO_READ && FD_ISSET(d->fd, rfds)) ||
-         (d->mode & OWL_IO_WRITE && FD_ISSET(d->fd, wfds)) ||
-         (d->mode & OWL_IO_EXCEPT && FD_ISSET(d->fd, efds)))) {
+    owl_io_dispatch *d = owl_list_get_element(dl, i);
+    if (!d->valid) continue;
+    if ((d->pollfd.revents & d->pollfd.events) && d->callback != NULL) {
       d->callback(d, d->data);
     }
@@ -213,21 +282,48 @@
   dispatch_active = 0;
   owl_select_io_dispatch_gc();
-}
+
+  return TRUE;
+}
+
+static GSourceFuncs owl_io_dispatch_funcs = {
+  owl_io_dispatch_prepare,
+  owl_io_dispatch_check,
+  owl_io_dispatch_dispatch,
+  NULL
+};
 
 int owl_select_add_perl_io_dispatch(int fd, int mode, SV *cb)
 {
-  const owl_io_dispatch *d = owl_select_find_io_dispatch_by_fd(fd);
+  const owl_io_dispatch *d = owl_select_find_valid_io_dispatch_by_fd(fd);
   if (d != NULL && d->callback != owl_perlconfig_io_dispatch) {
     /* Don't mess with non-perl dispatch functions from here. */
     return 1;
   }
+  /* Also remove any invalidated perl dispatch functions that may have
+   * stuck around. */
+  owl_select_remove_perl_io_dispatch(fd);
   owl_select_add_io_dispatch(fd, mode, owl_perlconfig_io_dispatch, owl_perlconfig_io_dispatch_destroy, cb);
   return 0;
 }
 
+static owl_io_dispatch *owl_select_find_perl_io_dispatch(int fd)
+{
+  int i, len;
+  const owl_list *dl;
+  owl_io_dispatch *d;
+  dl = owl_global_get_io_dispatch_list(&g);
+  len = owl_list_get_size(dl);
+  for(i = 0; i < len; i++) {
+    d = owl_list_get_element(dl, i);
+    if (d->fd == fd && d->callback == owl_perlconfig_io_dispatch)
+      return d;
+  }
+  return NULL;
+}
+
 int owl_select_remove_perl_io_dispatch(int fd)
 {
-  const owl_io_dispatch *d = owl_select_find_io_dispatch_by_fd(fd);
-  if (d != NULL && d->callback == owl_perlconfig_io_dispatch) {
+  owl_io_dispatch *d = owl_select_find_perl_io_dispatch(fd);
+  if (d != NULL) {
     /* Only remove perl io dispatchers from here. */
     owl_select_remove_io_dispatch(d);
@@ -237,217 +333,61 @@
 }
 
-int owl_select_aim_hack(fd_set *rfds, fd_set *wfds)
-{
-  aim_conn_t *cur;
-  aim_session_t *sess;
-  int max_fd;
-
-  max_fd = 0;
-  sess = owl_global_get_aimsess(&g);
-  for (cur = sess->connlist; cur; cur = cur->next) {
-    if (cur->fd != -1) {
-      FD_SET(cur->fd, rfds);
-      if (cur->status & AIM_CONN_STATUS_INPROGRESS) {
-        /* Yes, we're checking writable sockets here. Without it, AIM
-           login is really slow. */
-        FD_SET(cur->fd, wfds);
-      }
-      
-      if (cur->fd > max_fd)
-        max_fd = cur->fd;
-    }
-  }
-  return max_fd;
-}
-
-void owl_process_input_char(owl_input j)
-{
-  int ret;
-
-  owl_global_set_lastinputtime(&g, time(NULL));
-  ret = owl_keyhandler_process(owl_global_get_keyhandler(&g), j);
-  if (ret!=0 && ret!=1) {
-    owl_function_makemsg("Unable to handle keypress");
-  }
-}
-
-void owl_select_mask_signals(sigset_t *oldmask) {
-  sigset_t set;
-
-  sigemptyset(&set);
-  sigaddset(&set, SIGWINCH);
-  sigaddset(&set, SIGALRM);
-  sigaddset(&set, SIGPIPE);
-  sigaddset(&set, SIGTERM);
-  sigaddset(&set, SIGHUP);
-  sigaddset(&set, SIGINT);
-  sigprocmask(SIG_BLOCK, &set, oldmask);
-}
-
-void owl_select_handle_intr(sigset_t *restore)
-{
-  owl_input in;
-
-  owl_global_unset_interrupted(&g);
-
-  sigprocmask(SIG_SETMASK, restore, NULL);
-
-  in.ch = in.uch = owl_global_get_startup_tio(&g)->c_cc[VINTR];
-  owl_process_input_char(in);
-}
-
-owl_ps_action *owl_select_add_pre_select_action(int (*cb)(owl_ps_action *, void *), void (*destroy)(owl_ps_action *), void *data)
-{
-  owl_ps_action *a = g_new(owl_ps_action, 1);
-  owl_list *psa_list = owl_global_get_psa_list(&g);
-  a->needs_gc = 0;
-  a->callback = cb;
-  a->destroy = destroy;
-  a->data = data;
-  owl_list_append_element(psa_list, a);
-  return a;
-}
-
-void owl_select_psa_gc(void)
-{
-  int i;
-  owl_list *psa_list;
-  owl_ps_action *a;
-
-  psa_list = owl_global_get_psa_list(&g);
-  for (i = owl_list_get_size(psa_list) - 1; i >= 0; i--) {
-    a = owl_list_get_element(psa_list, i);
-    if (a->needs_gc) {
-      owl_list_remove_element(psa_list, i);
-      if (a->destroy) {
-        a->destroy(a);
-      }
-      g_free(a);
-    }
-  }
-}
-
-void owl_select_remove_pre_select_action(owl_ps_action *a)
-{
-  a->needs_gc = 1;
-  if (!psa_active)
-    owl_select_psa_gc();
-}
-
-int owl_select_do_pre_select_actions(void)
-{
-  int i, len, ret;
-  owl_list *psa_list;
-
-  psa_active = 1;
-  ret = 0;
-  psa_list = owl_global_get_psa_list(&g);
-  len = owl_list_get_size(psa_list);
-  for (i = 0; i < len; i++) {
-    owl_ps_action *a = owl_list_get_element(psa_list, i);
-    if (a->callback != NULL && a->callback(a, a->data)) {
-      ret = 1;
-    }
-  }
-  psa_active = 0;
-  owl_select_psa_gc();
-  return ret;
-}
-
-void owl_select(void)
-{
-  int i, max_fd, max_fd2, aim_done, ret;
-  fd_set r;
-  fd_set w;
-  fd_set e;
-  fd_set aim_rfds, aim_wfds;
-  struct timespec timeout;
-  sigset_t mask;
-
-  owl_select_process_timers(&timeout);
-
-  owl_select_mask_signals(&mask);
-
-  if(owl_global_is_interrupted(&g)) {
-    owl_select_handle_intr(&mask);
-    return;
-  }
-  FD_ZERO(&r);
-  FD_ZERO(&w);
-  FD_ZERO(&e);
-
-  max_fd = owl_select_prepare_io_dispatch_fd_sets(&r, &w, &e);
-
-  /* AIM HACK: 
-   *
-   *  The problem - I'm not sure where to hook into the owl/faim
-   *  interface to keep track of when the AIM socket(s) open and
-   *  close. In particular, the bosconn thing throws me off. So,
-   *  rather than register particular dispatchers for AIM, I look up
-   *  the relevant FDs and add them to select's watch lists, then
-   *  check for them individually before moving on to the other
-   *  dispatchers. --asedeno
-   */
-  aim_done = 1;
-  FD_ZERO(&aim_rfds);
-  FD_ZERO(&aim_wfds);
-  if (owl_global_is_doaimevents(&g)) {
-    aim_done = 0;
-    max_fd2 = owl_select_aim_hack(&aim_rfds, &aim_wfds);
-    if (max_fd < max_fd2) max_fd = max_fd2;
-    for(i = 0; i <= max_fd2; i++) {
-      if (FD_ISSET(i, &aim_rfds)) {
-        FD_SET(i, &r);
-        FD_SET(i, &e);
-      }
-      if (FD_ISSET(i, &aim_wfds)) {
-        FD_SET(i, &w);
-        FD_SET(i, &e);
-      }
-    }
-  }
-  /* END AIM HACK */
-
-  if (owl_select_do_pre_select_actions()) {
-    timeout.tv_sec = 0;
-    timeout.tv_nsec = 0;
-  }
-
-  ret = pselect(max_fd+1, &r, &w, &e, &timeout, &mask);
-
-  if(ret < 0 && errno == EINTR) {
-    if(owl_global_is_interrupted(&g)) {
-      owl_select_handle_intr(NULL);
-    }
-    sigprocmask(SIG_SETMASK, &mask, NULL);
-    return;
-  }
-
-  sigprocmask(SIG_SETMASK, &mask, NULL);
-
-  if(ret > 0) {
-    /* AIM HACK: process all AIM events at once. */
-    for(i = 0; !aim_done && i <= max_fd; i++) {
-      if (FD_ISSET(i, &r) || FD_ISSET(i, &w) || FD_ISSET(i, &e)) {
-        if (FD_ISSET(i, &aim_rfds) || FD_ISSET(i, &aim_wfds)) {
-          owl_process_aim();
-          aim_done = 1;
-        }
-      }
-    }
-    owl_select_io_dispatch(&r, &w, &e, max_fd);
-  }
+void owl_select_init(void)
+{
+  owl_timer_source = g_source_new(&owl_timer_funcs, sizeof(GSource));
+  g_source_attach(owl_timer_source, NULL);
+
+  owl_io_dispatch_source = g_source_new(&owl_io_dispatch_funcs, sizeof(GSource));
+  g_source_attach(owl_io_dispatch_source, NULL);
 }
 
 void owl_select_run_loop(void)
 {
-  loop_active = 1;
-  while (loop_active) {
-    owl_select();
-  }
+  main_context = g_main_context_default();
+  loop = g_main_loop_new(main_context, FALSE);
+  g_main_loop_run(loop);
 }
 
 void owl_select_quit_loop(void)
 {
-  loop_active = 0;
-}
+  if (loop) {
+    g_main_loop_quit(loop);
+    g_main_loop_unref(loop);
+    loop = NULL;
+  }
+}
+
+typedef struct _owl_task { /*noproto*/
+  void (*cb)(void *);
+  void *cbdata;
+  void (*destroy_cbdata)(void *);
+} owl_task;
+
+static gboolean _run_task(gpointer data)
+{
+  owl_task *t = data;
+  if (t->cb)
+    t->cb(t->cbdata);
+  return FALSE;
+}
+
+static void _destroy_task(void *data)
+{
+  owl_task *t = data;
+  if (t->destroy_cbdata)
+    t->destroy_cbdata(t->cbdata);
+  g_free(t);
+}
+
+void owl_select_post_task(void (*cb)(void*), void *cbdata, void (*destroy_cbdata)(void*), GMainContext *context)
+{
+  GSource *source = g_idle_source_new();
+  owl_task *t = g_new0(owl_task, 1);
+  t->cb = cb;
+  t->cbdata = cbdata;
+  t->destroy_cbdata = destroy_cbdata;
+  g_source_set_priority(source, G_PRIORITY_DEFAULT);
+  g_source_set_callback(source, _run_task, t, _destroy_task);
+  g_source_attach(source, context);
+  g_source_unref(source);
+}
Index: sepbar.c
===================================================================
--- sepbar.c	(revision 044f19f7c86e3f63b353e7fff2865f139319a45a)
+++ sepbar.c	(revision 6eb3ed9ee6c4b94d35628e5b6b2bbaeccca565a9)
@@ -16,4 +16,5 @@
   int x, y, i;
   const char *foo, *appendtosepbar;
+  int cur_numlines, cur_totallines;
 
   ml=owl_global_get_msglist(&g);
@@ -50,12 +51,4 @@
       wattron(sepwin, A_REVERSE);
 
-  if (owl_mainwin_is_curmsg_truncated(owl_global_get_mainwin(&g))) {
-    getyx(sepwin, y, x);
-    wmove(sepwin, y, x+2);
-    wattron(sepwin, A_BOLD);
-    waddstr(sepwin, " <truncated> ");
-    wattroff(sepwin, A_BOLD);
-  }
-
   i=owl_mainwin_get_last_msg(owl_global_get_mainwin(&g));
   if ((i != -1) &&
@@ -90,4 +83,14 @@
   }
 
+  if (owl_mainwin_is_curmsg_truncated(owl_global_get_mainwin(&g))) {
+    getyx(sepwin, y, x);
+    wmove(sepwin, y, x+2);
+    wattron(sepwin, A_BOLD);
+    cur_numlines = owl_global_get_curmsg_vert_offset(&g) + 1;
+    cur_totallines = owl_message_get_numlines(owl_view_get_element(v, owl_global_get_curmsg(&g)));
+    wprintw(sepwin, " <truncated: %d/%d> ", cur_numlines, cur_totallines);
+    wattroff(sepwin, A_BOLD);
+  }
+
   if (owl_global_get_curmsg_vert_offset(&g)) {
     getyx(sepwin, y, x);
Index: signal.c
===================================================================
--- signal.c	(revision 1d21d9fd6efdecb79b0bef96aabee3943d6a955a)
+++ signal.c	(revision 1d21d9fd6efdecb79b0bef96aabee3943d6a955a)
@@ -0,0 +1,62 @@
+#include <errno.h>
+#include <pthread.h>
+#include <signal.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+static pthread_t signal_thread;
+static sigset_t signal_set;
+
+static void (*signal_cb)(const siginfo_t*, void*);
+static void *signal_cbdata;
+
+static void *signal_thread_func(void *data);
+
+/* Initializes the signal thread to listen for 'set' on a dedicated
+ * thread. 'callback' is called *on the signal thread* when a signal
+ * is received.
+ *
+ * This function /must/ be called before any other threads are
+ * created. (Otherwise the signals will not get blocked correctly.) */
+void owl_signal_init(const sigset_t *set, void (*callback)(const siginfo_t*, void*), void *data) {
+  int ret;
+
+  signal_set = *set;
+  signal_cb = callback;
+  signal_cbdata = data;
+  /* Block these signals in all threads, so we can get them. */
+  if ((ret = pthread_sigmask(SIG_BLOCK, set, NULL)) != 0) {
+    errno = ret;
+    perror("pthread_sigmask");
+  }
+  /* Spawn a dedicated thread to sigwait. */
+  if ((ret = pthread_create(&signal_thread, NULL,
+                            signal_thread_func, NULL)) != 0) {
+    errno = ret;
+    perror("pthread_create");
+    exit(1);
+  }
+}
+
+static void *signal_thread_func(void *data) {
+  while (1) {
+    siginfo_t siginfo;
+    int ret;
+
+    ret = sigwaitinfo(&signal_set, &siginfo);
+    /* TODO: Print an error? */
+    if (ret < 0)
+      continue;
+
+    signal_cb(&siginfo, signal_cbdata);
+    /* Die on SIGTERM. */
+    if (siginfo.si_signo == SIGTERM)
+      break;
+  }
+  return NULL;
+}
+
+void owl_signal_shutdown(void) {
+  pthread_kill(signal_thread, SIGTERM);
+  pthread_join(signal_thread, NULL);
+}
Index: tester.c
===================================================================
--- tester.c	(revision f25df21f6284aedd48c098bc68cee9896da5ce98)
+++ tester.c	(revision e93dd785a2e76aa0dc14ecd56fd2c61b3598bc96)
@@ -32,4 +32,5 @@
   char *perlerr;
   int status = 0;
+  SCREEN *screen;
 
   if (argc <= 1) {
@@ -41,5 +42,5 @@
   wnull = fopen("/dev/null", "w");
   rnull = fopen("/dev/null", "r");
-  newterm("xterm", wnull, rnull);
+  screen = newterm("xterm", wnull, rnull);
   /* initialize global structures */
   owl_global_init(&g);
@@ -91,4 +92,5 @@
   /* probably not necessary, but tear down the screen */
   endwin();
+  delscreen(screen);
   fclose(rnull);
   fclose(wnull);
@@ -218,6 +220,6 @@
   owl_string_appendf_quoted(g, "%q foo %q%q %s %", "hello", "world is", "can't");
   FAIL_UNLESS("owl_string_appendf",
-              !strcmp(g_string_free(g, false),
-                      "hello foo 'world is'\"can't\" %s %"));
+              !strcmp(g->str, "hello foo 'world is'\"can't\" %s %"));
+  g_string_free(g, true);
 
   /* if (numfailed) printf("*** WARNING: failures encountered with owl_util\n"); */
@@ -233,5 +235,5 @@
 
   printf("# BEGIN testing owl_dict\n");
-  FAIL_UNLESS("create", 0==owl_dict_create(&d));
+  owl_dict_create(&d);
   FAIL_UNLESS("insert b", 0==owl_dict_insert_element(&d, "b", bv, owl_dict_noop_delete));
   FAIL_UNLESS("insert d", 0==owl_dict_insert_element(&d, "d", dv, owl_dict_noop_delete));
@@ -249,5 +251,5 @@
   FAIL_UNLESS("get_size", 3==owl_dict_get_size(&d));
   owl_list_create(&l);
-  FAIL_UNLESS("get_keys", 0==owl_dict_get_keys(&d, &l));
+  owl_dict_get_keys(&d, &l);
   FAIL_UNLESS("get_keys result size", 3==owl_list_get_size(&l));
   
Index: text.c
===================================================================
--- text.c	(revision 42ee1befb24d0ac6b39443512cd22be47a782563)
+++ text.c	(revision 7865479440dd042766ecbbc1119b45e5eb7cd6a6)
@@ -275,18 +275,4 @@
   g_strfreev(split);
   return out;
-}
-
-/* replace all instances of character a in buff with the character
- * b.  buff must be null terminated.
- */
-void owl_text_tr(char *buff, char a, char b)
-{
-  int i;
-
-  owl_function_debugmsg("In: %s", buff);
-  for (i=0; buff[i]!='\0'; i++) {
-    if (buff[i]==a) buff[i]=b;
-  }
-  owl_function_debugmsg("Out: %s", buff);
 }
 
Index: util.c
===================================================================
--- util.c	(revision e56303f7b60f05cc30e74453b06725fc031e9384)
+++ util.c	(revision 83a4af3422d232d9ef981a5a009e31549c839a14)
@@ -455,5 +455,5 @@
     g_free(newfile);
     fclose(old);
-    free(actual_filename);
+    g_free(actual_filename);
     return -1;
   }
@@ -466,5 +466,5 @@
     g_free(newfile);
     fclose(old);
-    free(actual_filename);
+    g_free(actual_filename);
     return -1;
   }
@@ -715,4 +715,15 @@
 }
 
+int owl_util_get_colorpairs(void) {
+#ifndef NCURSES_EXT_COLORS
+  /* Without ext-color support (an ABI change), ncurses only supports 256
+   * different color pairs. However, it gives us a larger number even if your
+   * ncurses is compiled without ext-color. */
+  return MIN(COLOR_PAIRS, 256);
+#else
+  return COLOR_PAIRS;
+#endif
+}
+
 gulong owl_dirty_window_on_signal(owl_window *w, gpointer sender, const gchar *detailed_signal)
 {
Index: variable.c
===================================================================
--- variable.c	(revision f203cad04d71e968a11be5e72e6c9d805e02010d)
+++ variable.c	(revision 4c7c21f786a0416a755645b78db0b851f75f8748)
@@ -559,5 +559,5 @@
 int owl_variable_dict_setup(owl_vardict *vd) {
   owl_variable *var, *cur;
-  if (owl_dict_create(vd)) return(-1);
+  owl_dict_create(vd);
   for (var = variables_to_init; var->name != NULL; var++) {
     cur = g_new(owl_variable, 1);
@@ -641,7 +641,7 @@
 
 void owl_variable_update(owl_variable *var, const char *summary, const char *desc) {
-  if(var->summary) g_free(var->summary);
+  g_free(var->summary);
   var->summary = g_strdup(summary);
-  if(var->description) g_free(var->description);
+  g_free(var->description);
   var->description = g_strdup(desc);
 }
@@ -651,5 +651,5 @@
   if(old) {
     owl_variable_update(old, summ, desc);
-    if(old->pval_default) g_free(old->pval_default);
+    g_free(old->pval_default);
     old->pval_default = g_strdup(initval);
   } else {
@@ -944,5 +944,5 @@
 void owl_variable_delete_default(owl_variable *v)
 {
-  if (v->val) g_free(v->val);
+  g_free(v->val);
 }
 
@@ -1076,5 +1076,5 @@
     if (!v->validate_fn(v, newval)) return(-1);
   }
-  if (v->val) g_free(v->val);
+  g_free(v->val);
   v->val = g_strdup(newval);
   return(0);
Index: view.c
===================================================================
--- view.c	(revision d4927a70549407fe7f56b4ae1d3949663a370205)
+++ view.c	(revision 3b8a563ae4e07b1064fe005714793565ac720dc4)
@@ -160,4 +160,4 @@
 {
   owl_list_cleanup(&v->ml.list, NULL);
-  if (v->name) g_free(v->name);
+  g_free(v->name);
 }
Index: window.c
===================================================================
--- window.c	(revision b31f1c9929b526b6d90b18b7847a024ff3d0c77d)
+++ window.c	(revision 4cc49bce5bdc20cd8da2b4e305f60d04ae879d4f)
@@ -524,2 +524,53 @@
   owl_window_set_position(w, nlines, ncols, w->begin_y, w->begin_x);
 }
+
+/** Redrawing main loop hooks **/
+
+static bool _owl_window_should_redraw(void) {
+  return g.resizepending || owl_window_get_screen()->dirty_subtree;
+}
+
+static gboolean _owl_window_redraw_prepare(GSource *source, int *timeout) {
+  *timeout = -1;
+  return _owl_window_should_redraw();
+}
+
+static gboolean _owl_window_redraw_check(GSource *source) {
+  return _owl_window_should_redraw();
+}
+
+static gboolean _owl_window_redraw_dispatch(GSource *source, GSourceFunc callback, gpointer user_data) {
+  owl_colorpair_mgr *cpmgr;
+
+  /* if a resize has been scheduled, deal with it */
+  owl_global_check_resize(&g);
+  /* update the terminal if we need to */
+  owl_window_redraw_scheduled();
+  /* On colorpair shortage, reset and redraw /everything/. NOTE: if we
+   * still overflow, this be useless work. With 8-colors, we get 64
+   * pairs. With 256-colors, we get 32768 pairs with ext-colors
+   * support and 256 otherwise. */
+  cpmgr = owl_global_get_colorpair_mgr(&g);
+  if (cpmgr->overflow) {
+    owl_function_debugmsg("colorpairs: used all %d pairs; reset pairs and redraw.",
+                          owl_util_get_colorpairs());
+    owl_fmtext_reset_colorpairs(cpmgr);
+    owl_function_full_redisplay();
+    owl_window_redraw_scheduled();
+  }
+  return TRUE;
+}
+
+static GSourceFuncs redraw_funcs = {
+  _owl_window_redraw_prepare,
+  _owl_window_redraw_check,
+  _owl_window_redraw_dispatch,
+  NULL
+};
+
+GSource *owl_window_redraw_source_new(void) {
+  GSource *source;
+  source = g_source_new(&redraw_funcs, sizeof(GSource));
+  /* TODO: priority?? */
+  return source;
+}
Index: window.h
===================================================================
--- window.h	(revision 28da2daf4548256b44d1fd586200032e96462d57)
+++ window.h	(revision 4cc49bce5bdc20cd8da2b4e305f60d04ae879d4f)
@@ -62,4 +62,6 @@
 void owl_window_resize(owl_window *w, int nlines, int ncols);
 
+GSource *owl_window_redraw_source_new(void);
+
 /* Standard callback functions in windowcb.c */
 
Index: zcrypt.c
===================================================================
--- zcrypt.c	(revision 1dd285b0045528991a838942c7ba925dbcf64128)
+++ zcrypt.c	(revision 5b197f71370f5a5b3c3c09935c5679d6c90fa4c2)
@@ -11,5 +11,4 @@
 #include <unistd.h>
 #include <sys/types.h>
-#include <zephyr/zephyr.h>
 #include <glib.h>
 #include <string.h>
@@ -476,12 +475,8 @@
 
   for(i = 0; i < MAX_SEARCH; i++) {
-    if(varname[i] != NULL) {
-      g_free(varname[i]);
-    }
-  }
-
-  if(filename != NULL) {
-    g_free(filename);
-  }
+    g_free(varname[i]);
+  }
+
+  g_free(filename);
 
   return keyfile;
@@ -773,5 +768,5 @@
   err = call_filter("gpg", argv, in, &out, &status);
   if(err || status) {
-    if(out) g_free(out);
+    g_free(out);
     return FALSE;
   }
@@ -856,5 +851,5 @@
   err = call_filter("gpg", argv, in, &out, &status);
   if(err || status) {
-    if(out) g_free(out);
+    g_free(out);
     return FALSE;
   }
Index: zephyr.c
===================================================================
--- zephyr.c	(revision f203cad04d71e968a11be5e72e6c9d805e02010d)
+++ zephyr.c	(revision b848e308e9f8f212ddbf787f08111af994000512)
@@ -8,4 +8,10 @@
 
 #ifdef HAVE_LIBZEPHYR
+static GSource *owl_zephyr_event_source_new(int fd);
+
+static gboolean owl_zephyr_event_prepare(GSource *source, int *timeout);
+static gboolean owl_zephyr_event_check(GSource *source);
+static gboolean owl_zephyr_event_dispatch(GSource *source, GSourceFunc callback, gpointer user_data);
+
 static GList *deferred_subs = NULL;
 
@@ -16,4 +22,11 @@
 
 Code_t ZResetAuthentication(void);
+
+static GSourceFuncs zephyr_event_funcs = {
+  owl_zephyr_event_prepare,
+  owl_zephyr_event_check,
+  owl_zephyr_event_dispatch,
+  NULL
+};
 #endif
 
@@ -84,4 +97,5 @@
   Code_t code;
   char *perl;
+  GSource *event_source;
 
   owl_select_remove_io_dispatch(d);
@@ -99,5 +113,7 @@
   }
 
-  owl_select_add_io_dispatch(ZGetFD(), OWL_IO_READ|OWL_IO_EXCEPT, &owl_zephyr_process_events, NULL, NULL);
+  event_source = owl_zephyr_event_source_new(ZGetFD());
+  g_source_attach(event_source, NULL);
+  g_source_unref(event_source);
 
   owl_global_set_havezephyr(&g);
@@ -127,6 +143,4 @@
   perl = owl_perlconfig_execute("BarnOwl::Zephyr::_zephyr_startup()");
   g_free(perl);
-
-  owl_select_add_pre_select_action(owl_zephyr_pre_select_action, NULL, NULL);
 }
 
@@ -180,4 +194,20 @@
     if((code = ZPending()) < 0) {
       owl_function_debugmsg("Error (%s) in ZPending()\n",
+                            error_message(code));
+      return 0;
+    }
+    return code;
+  }
+#endif
+  return 0;
+}
+
+int owl_zephyr_zqlength(void)
+{
+#ifdef HAVE_LIBZEPHYR
+  Code_t code;
+  if(owl_global_is_havezephyr(&g)) {
+    if((code = ZQLength()) < 0) {
+      owl_function_debugmsg("Error (%s) in ZQLength()\n",
                             error_message(code));
       return 0;
@@ -417,6 +447,5 @@
     return 0;
   }
-  if (buffer)
-    g_free(buffer);
+  g_free(buffer);
 
   return owl_zephyr_loadsubs_helper(subs, count);
@@ -1422,8 +1451,8 @@
 #define OWL_MAX_ZEPHYRGRAMS_TO_PROCESS 20
 
+#ifdef HAVE_LIBZEPHYR
 static int _owl_zephyr_process_events(void)
 {
   int zpendcount=0;
-#ifdef HAVE_LIBZEPHYR
   ZNotice_t notice;
   Code_t code;
@@ -1466,15 +1495,40 @@
     }
   }
-#endif
   return zpendcount;
 }
 
-void owl_zephyr_process_events(const owl_io_dispatch *d, void *data)
-{
+typedef struct { /*noproto*/
+  GSource source;
+  GPollFD poll_fd;
+} owl_zephyr_event_source;
+
+static GSource *owl_zephyr_event_source_new(int fd) {
+  GSource *source;
+  owl_zephyr_event_source *event_source;
+
+  source = g_source_new(&zephyr_event_funcs, sizeof(owl_zephyr_event_source));
+  event_source = (owl_zephyr_event_source*) source;
+  event_source->poll_fd.fd = fd;
+  event_source->poll_fd.events = G_IO_IN | G_IO_HUP | G_IO_PRI | G_IO_ERR;
+  g_source_add_poll(source, &event_source->poll_fd);
+
+  return source;
+}
+
+static gboolean owl_zephyr_event_prepare(GSource *source, int *timeout) {
+  *timeout = -1;
+  return owl_zephyr_zqlength() > 0;
+}
+
+static gboolean owl_zephyr_event_check(GSource *source) {
+  owl_zephyr_event_source *event_source = (owl_zephyr_event_source*)source;
+  if (event_source->poll_fd.revents & event_source->poll_fd.events)
+    return owl_zephyr_zpending() > 0;
+  return FALSE;
+}
+
+static gboolean owl_zephyr_event_dispatch(GSource *source, GSourceFunc callback, gpointer user_data) {
   _owl_zephyr_process_events();
-}
-
-int owl_zephyr_pre_select_action(owl_ps_action *a, void *p)
-{
-  return _owl_zephyr_process_events();
-}
+  return TRUE;
+}
+#endif
